SystemOrganization addCategory: #'FFI-PoolsTests'!

FFIExternalSharedPoolProgramGenerator subclass: #FFITestExternalSharedPoolProgramGenreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestExternalSharedPoolProgramGenreator commentStamp: 'monty 4/1/2018 07:47' prior: 0!
A stub used during testing.!

FFIExternalSharedPool subclass: #FFIExampleStandardExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: 'EAGAIN EIO EWOULDBLOCK INT_MAX M_E M_PI ULONG_MAX'
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFIExampleStandardExternalSharedPool commentStamp: 'monty 4/17/2018 13:15' prior: 0!
A buildable example FFIExternalSharedPool that uses standard POSIX headers and symbols.

	self generateProgram.
	self initializeFromGeneratedProgramOutput.!

!FFIExampleStandardExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:40'!
errors
	<ffiExternalSharedPool>
	<ffiCHeaders: #('<errno.h>')>
	<ffiVariable: #EAGAIN type: #Integer>
	<ffiVariable: #EWOULDBLOCK type: #Integer>
	<ffiVariable: #EIO type: nil>
	<ffiVariable: #M_PI type: nil>
	<ffiVariable: #M_E type: nil>
	<ffiVariable: #ULONG_MAX type: nil>
	<ffiVariable: #INT_MAX type: nil>! !

!FFIExampleStandardExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/2/2018 08:02'!
limits
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #math>
	<ffiPlatformName: 'unix' wordSize: 4>
	<ffiCFlags: '-Wall -o'>
	<ffiCHeaders: #('<math.h>' '<errno.h>' '<limits.h>')>
	<ffiVariable: #ULONG_MAX type: #LargePositiveInteger>
	<ffiVariable: #INT_MAX type: #Integer>! !

!FFIExampleStandardExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:39'!
math
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #errors>
	<ffiPlatformName: 'unix'>
	<ffiCHeaders: #('<errno.h>' '<math.h>')>
	<ffiVariable: #M_PI type: #Float>
	<ffiVariable: #M_E type: #Float>! !

FFIExternalSharedPool subclass: #FFITestExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestExternalSharedPool commentStamp: 'monty 4/1/2018 10:30' prior: 0!
These classes are used during testing and are not buildable.!

FFITestExternalSharedPool subclass: #FFITestDefaultDefinitionSharedPool
	instanceVariableNames: ''
	classVariableNames: 'One'
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestExternalSharedPool class methodsFor: 'testing' stamp: 'monty 4/1/2018 07:46'!
isSkipped
	"all of these classes are skipped during program generation and initialization"
	^ true! !

FFITestExternalSharedPool subclass: #FFITestInheritanceExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: 'One Two'
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestInheritanceExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 05:58'!
empty
	<ffiExternalSharedPool>! !

!FFITestInheritanceExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 06:18'!
override
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #empty>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype' wordSize: 16>
	<ffiCCompiler: 'testCompiler'>
	<ffiCFlags: 'testFlags'>
	<ffiCHeaders: #('<testHeader.h>' '"testLocalHeader.h"' 'testImplicitGlobalHeader.h')>
	<ffiProgramGenerator: #FFITestExternalSharedPoolProgramGenreator>
	<ffiVariable: #One type: #Float>! !

FFITestExternalSharedPool subclass: #FFITestLoopOneExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestLoopOneExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/31/2018 07:06'!
one
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #one>! !

FFITestExternalSharedPool subclass: #FFITestLoopThreeExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestLoopThreeExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
one
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #three>! !

!FFITestLoopThreeExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
three
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #two>! !

!FFITestLoopThreeExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
two
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #one>! !

FFITestExternalSharedPool subclass: #FFITestLoopTwoExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestLoopTwoExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
one
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #two>! !

!FFITestLoopTwoExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
two
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #one>! !

FFITestExternalSharedPool subclass: #FFITestPlatformAliasingExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: 'One Two'
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestPlatformAliasingExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:08'!
five
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype' wordSize: 32>! !

!FFITestPlatformAliasingExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:06'!
four
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype' wordSize: 16>! !

!FFITestPlatformAliasingExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:02'!
one
	<ffiExternalSharedPool>! !

!FFITestPlatformAliasingExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:05'!
three
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype' wordSize: 16>! !

!FFITestPlatformAliasingExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 10:02'!
two
	<ffiExternalSharedPool>! !

FFITestExternalSharedPool subclass: #FFITestPlatformExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestPlatformExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/31/2018 13:08'!
definitionWithName
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName'>! !

!FFITestPlatformExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/31/2018 13:08'!
definitionWithNameOSVersion
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion'>! !

!FFITestPlatformExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/31/2018 13:08'!
definitionWithNameOSVersionSubtype
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype'>! !

!FFITestPlatformExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 06:12'!
definitionWithNameOSVersionSubtypeWordSize
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' osVersion: 'testOSVersion' subtype: 'testSubtype' wordSize: 16>! !

!FFITestPlatformExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 4/1/2018 06:13'!
definitionWithNameWordSize
	<ffiExternalSharedPool>
	<ffiPlatformName: 'testName' wordSize: 16>! !

FFITestExternalSharedPool subclass: #FFITestTypesExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: 'Five Four One Six Three Two Zero'
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestTypesExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/31/2018 13:37'!
types
	<ffiExternalSharedPool>
	<ffiVariable: #One type: #Integer>
	<ffiVariable: #Two type: #Float>
	<ffiVariable: #Three type: #String>
	<ffiVariable: #Four type: #Character>
	<ffiVariable: #Five type: #Boolean>
	<ffiVariable: #Six type: #LargePositiveInteger>! !

FFITestExternalSharedPool subclass: #FFITestUnknownReferenceExternalSharedPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFITestUnknownReferenceExternalSharedPool class methodsFor: 'definitions' stamp: 'monty 3/30/2018 02:15'!
one
	<ffiExternalSharedPool>
	<ffiInheritsFrom: #unknown>! !

TestCase subclass: #FFIExternalSharedPoolProgramGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFIExternalSharedPoolProgramGeneratorTest methodsFor: 'instance creation' stamp: 'monty 4/6/2018 07:42'!
newProgramGenerator
	^ self programGeneratorClass
		on: String new writeStream
		definition: FFITestExternalSharedPool defaultDefinition! !

!FFIExternalSharedPoolProgramGeneratorTest methodsFor: 'accessing' stamp: 'monty 4/6/2018 07:49'!
programGeneratorClass
	^ FFIExternalSharedPoolProgramGenerator! !

!FFIExternalSharedPoolProgramGeneratorTest methodsFor: 'tests' stamp: 'monty 4/6/2018 07:56'!
testEmitAllFormat
	| programGenerator |

	programGenerator := self newProgramGenerator.
	self assert:
		(programGenerator
			emitAll: '${1}two${2}$two$${1}'
			format: {'one'. 'three'}) == programGenerator.
	self assert: programGenerator contents = 'onetwothree$two$one'.

	programGenerator := self newProgramGenerator.
	self assert:
		(programGenerator
			emitAll: '${one}two${three}$two$${one}'
			format: {'one' -> 1. 'three' -> 3} asDictionary) == programGenerator.
	self assert: programGenerator contents = '1two3$two$1'.

	self
		should: [
			self newProgramGenerator
				emitAll: '${1}${2}'
				format: {1}]
		raise: Error.
	self
		should: [
			self newProgramGenerator
				emitAll: '${one}${two}'
				format: {'one' -> 1} asDictionary]
		raise: Error.! !

!FFIExternalSharedPoolProgramGeneratorTest methodsFor: 'tests' stamp: 'monty 4/6/2018 08:05'!
testLineEnding
	{Character cr. Character lf. String crlf. 'NL'. $N}
		do: [:each | | programGenerator leString |
			programGenerator := self newProgramGenerator.
			self assert: (programGenerator lineEnding: each) == programGenerator.

			leString := each asString.
			self
				assert: programGenerator lineEnding
				equals: leString.

			programGenerator
				emitAll: 'one';
				emitLineEnding;
				emitAll: 'two', String lf, 'three';
				emit: Character cr;
				emitAll: 'four'.
			self
				assert: programGenerator contents
				equals:
					'one', leString, 'two', leString, 'three', leString, 'four']! !

TestCase subclass: #FFIExternalSharedPoolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FFI-PoolsTests'!

!FFIExternalSharedPoolTest methodsFor: 'asserting' stamp: 'monty 4/2/2018 06:05'!
assertIsDefaultDefinition: aDefinition for: aSharedPool
	| classPool |

	self
		assert: aDefinition isDefault;
		assert: aDefinition name isNil;
		assert: aDefinition inheritsFrom isNil;
		assert: aDefinition cCompiler equals: self definitionClass defaultCCompiler;
		assert: aDefinition cFlags equals: self definitionClass defaultCFlags;
		assert: aDefinition cHeaders equals: self definitionClass defaultCHeaders;
		assert: aDefinition platform equals: self platformClass empty.
	self
		assert: aDefinition programGeneratorClass
		equals: self definitionClass defaultProgramGeneratorClass.
	
	classPool := aSharedPool classPool.
	classPool keysDo: [:each |
		self
			assert: (aDefinition variablesAndTypesAt: each)
			equals: Integer].
	self
		assert: classPool size
		equals: aDefinition variablesAndTypes size.! !

!FFIExternalSharedPoolTest methodsFor: 'defaults' stamp: 'monty 4/1/2018 06:01'!
definitionClass
	^ FFIExternalSharedPoolDefinition! !

!FFIExternalSharedPoolTest methodsFor: 'instance creation' stamp: 'monty 4/1/2018 06:12'!
newTestPlatform
	^ self platformClass
		name: 'testName'
		osVersion: 'testOSVersion'
		subtype: 'testSubtype'
		wordSize: 16.! !

!FFIExternalSharedPoolTest methodsFor: 'defaults' stamp: 'monty 3/31/2018 12:57'!
platformClass
	^ FFIExternalSharedPoolPlatform! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/1/2018 10:27'!
testDefaultDefinition
	| sharedPool |

	sharedPool := FFITestDefaultDefinitionSharedPool.

	self assert: (sharedPool resolvedDefinitions) size equals: 1.

	self
		assertIsDefaultDefinition:
			(sharedPool preferredResolvedDefinitionForPlatform:
				self newTestPlatform)
		for: sharedPool.! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/3/2018 05:27'!
testDefinitionLoops
	{FFITestLoopOneExternalSharedPool.
		FFITestLoopTwoExternalSharedPool.
		FFITestLoopThreeExternalSharedPool}
		do: [:sharedPool |
			self
				shouldnt: [sharedPool definitions]
				raise: FFIExternalSharedPoolException.
			self
				should: [sharedPool resolvedDefinitions]
				raise: FFIExternalSharedPoolException.
			self
				shouldnt: [
					sharedPool resolvedDefinitions:
						(sharedPool definitions collect: [:each |
							each inheritsFrom: nil])]
				raise: FFIExternalSharedPoolException].! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/3/2018 05:27'!
testDefinitionUnkownReferences
	| sharedPool |

	sharedPool := FFITestUnknownReferenceExternalSharedPool.
	self
		shouldnt: [sharedPool definitions]
		raise: FFIExternalSharedPoolException.
	self
		should: [sharedPool resolvedDefinitions]
		raise: FFIExternalSharedPoolException.
	self
		shouldnt: [
			sharedPool resolvedDefinitions:
				(sharedPool definitions collect: [:each |
					each inheritsFrom: nil])]
		raise: FFIExternalSharedPoolException.! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/2/2018 06:07'!
testInheritance
	| sharedPool definitions defaultDefinition emptyDefinition overrideDefinition |

	sharedPool := FFITestInheritanceExternalSharedPool.
	definitions := sharedPool resolvedDefinitions.
	self assert: definitions size equals: 3.

	defaultDefinition := definitions detect: [:each | each isDefault].
	emptyDefinition := definitions detect: [:each | each name = #empty].
	overrideDefinition := definitions detect: [:each | each name = #override].
	self
		assertIsDefaultDefinition: defaultDefinition
		for: sharedPool.

	self
		deny: emptyDefinition isDefault;
		assert: emptyDefinition inheritsFrom isNil;
		assert: emptyDefinition cCompiler equals: defaultDefinition cCompiler;
		assert: emptyDefinition cFlags equals: defaultDefinition cFlags;
		assert: emptyDefinition cHeaders equals: defaultDefinition cHeaders;
		assert: emptyDefinition platform equals: defaultDefinition platform;
		assert: emptyDefinition programGeneratorClass equals: defaultDefinition programGeneratorClass;
		assert: emptyDefinition variablesAndTypes equals: defaultDefinition variablesAndTypes.

	self
		deny: overrideDefinition isDefault;
		assert: overrideDefinition inheritsFrom equals: #empty;
		assert: overrideDefinition cCompiler equals: 'testCompiler';
		assert: overrideDefinition cFlags equals: 'testFlags';
		assert: overrideDefinition cHeaders
			equals: #('<testHeader.h>' '"testLocalHeader.h"' '<testImplicitGlobalHeader.h>');
		assert: overrideDefinition platform equals: self newTestPlatform;
		assert: overrideDefinition programGeneratorClass
			equals: FFITestExternalSharedPoolProgramGenreator;
		assert: overrideDefinition variablesAndTypes
			equals: {#One -> Float. #Two -> Integer} asDictionary.! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/3/2018 05:27'!
testPlatformAliasing
	| sharedPool definition |

	sharedPool := FFITestPlatformAliasingExternalSharedPool.
	self
		should: [
			sharedPool preferredResolvedDefinitionForPlatform:
				self platformClass empty]
		raise: FFIExternalSharedPoolException.
	self
		should: [
			sharedPool preferredResolvedDefinitionForPlatform:
				self newTestPlatform]
		raise: FFIExternalSharedPoolException.
	self
		shouldnt: [
			definition :=
				sharedPool preferredResolvedDefinitionForPlatform:
					(self newTestPlatform wordSize: 32)]
		raise: FFIExternalSharedPoolException.

	self assert: definition name equals: #five.! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 4/1/2018 06:12'!
testPlatformPrecedence
	| currentPlatform sharedPool |

	currentPlatform := self newTestPlatform.
	sharedPool := FFITestPlatformExternalSharedPool.
	self
		assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) name
		equals: #definitionWithNameOSVersionSubtypeWordSize.

	currentPlatform wordSize: 32.
	self
		assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) name
		equals: #definitionWithNameOSVersionSubtype.

	currentPlatform subtype: 'otherSubtype'.
	self
		assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) name
		equals: #definitionWithNameOSVersion.

	currentPlatform osVersion: 'otherOSVersion'.
	self
		assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) name
		equals: #definitionWithName.

	currentPlatform wordSize: 16.
	self
		assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) name
		equals: #definitionWithNameWordSize.

	currentPlatform name: 'otherName'.
	self assert: (sharedPool preferredResolvedDefinitionForPlatform: currentPlatform) isDefault.! !

!FFIExternalSharedPoolTest methodsFor: 'tests' stamp: 'monty 3/31/2018 13:43'!
testVariableTypes
	| sharedPool resolvedDefinitions variables|

	sharedPool := FFITestTypesExternalSharedPool.
	resolvedDefinitions := sharedPool resolvedDefinitions.
	self
		assert: resolvedDefinitions size
		equals: 2.
	variables := #(Zero One Two Three Four Five Six).
	resolvedDefinitions do: [:definition |
		definition isDefault
			ifTrue: [
				variables do: [:each |
					self
						assert: (definition variablesAndTypesAt: each)
						equals: Integer]]
			ifFalse: [
				variables
					with:
						{Integer. Integer. Float. String.
							Character. Boolean. LargePositiveInteger}
					do: [:variable :type |
						self
							assert: (definition variablesAndTypesAt: variable)
							equals: type]]].! !
